{$G+}
UNIT nexusint;
INTERFACE
USES GP15;
type
 pcxheadertyp = record
 kennung      : byte;
 version      : byte;
 kodierung    : byte;{ Art der Kodierung, 1 fr Standardkodierung }
 bitspixel    : byte;{ Anzahl Bits pro Pixel, hier 8 (ein Byte) }
 xstart       : word;{ x-Koordinate der linken oberen Bildecke }
 ystart       : word;{ y-Koordinate der linken oberen Bildecke }
 xende        : word;{ x-Koordinate der rechten unteren Bildecke }
 yende        : word;{ y-Koordinate der rechten unteren Bildecke }
 x_aufl       : word;{ horizontale Bildschirmauflsung }
 y_aufl       : word;{ vertikale Bildschirmauflsung }
 palette      : array[17..64] of byte;{ 16-Farben-Palette, bei einem 256-Farben-Bild unbedeutend }
 reserviert   : byte;{ zur Zeit noch nicht belegt, also 0 }
 anzebenen    : byte;{ Anzahl der Farbebenen, in diesem Fall 1 }
 byteszeile   : word;{ Anzahl Bytes der unkomprimierten Bildschirmzeile }
 palettentyp  : word;{ Art der Palette, 1 fr Farbbild }
 dummy        : array[71..128] of byte;{ nicht belegt }
end;
 palettenarray = array[0..255,1..3] of byte;
 zeichenarray  = array[0..255,0..7] of byte;
var
 zeichensatz                                             : zeichenarray;
 seite,bbreite                           : word;
 rot,gruen,blau,fc : byte;
 ze                                                      : char;
 wieoft                                                  : integer;
 sprung                                                  : pointer;
 pufferpalette,blendepal                        : palettenarray;

{GIF.Bild-Variablen}
 gifname         : string[12];
 temppic         : pointer;
 puf,palette     : array[0..767] of byte;
 stack           : array[0..1280] of byte;
 ab_prfx,ab_tail : array[0..4096] of word;
 pufInd,handle,free,breite,max,stackp,restbits,restbyte,
 sonderfall,lbyte,code,old_code,readbyt,bits,bits2get:word;

procedure glinie(x1,x2,y:word;farbe:byte);
procedure videomodus;
procedure enter400;
procedure enter200;
procedure textmodus;
procedure altvideomodus;
procedure enable;
procedure disable;
procedure waitretrace;
procedure waitdisplay;
procedure aktiveadresse(x,y:word);
procedure startadresse(x,y:word);
procedure bildbreite(br:word);
procedure aktiveseite(seit:byte);
procedure seiteanzeigen(seit:byte);
procedure seitekopieren(qpage,zpage:word);
procedure cls(nr:word);
procedure altcls;
procedure punkt(x,y:word;farbe:byte);
function  punktfarbe(x,y:word):byte;
procedure extrafarbe(farben,r,g,b:byte);
procedure extrafarbelesen(farben:byte);
procedure paletteschreiben(var palette:palettenarray;farbenstart,farbenende:byte);
procedure palettelesen(var palette:palettenarray;farbenstart,farbenende:byte);
procedure palettespeichern(var palette:palettenarray;dateiname:string);
procedure paletteladen(var palette:palettenarray;dateiname:string;start:longint);
procedure gifladen(dateiname:string);
procedure bildladen(dateiname:string;altneu:boolean;start,ende:longint);
procedure standardzeichensatzladen;
procedure readkey;
function  keypressed:boolean;
procedure switchoff;
procedure switchon;
procedure warte(i:word);
procedure paletteein(wielange:byte);
procedure paletteaus(wielange:byte);
procedure blitzeinall;
procedure blitzausall;
procedure blitzein;
procedure blitzaus;
function wurzel(zahl:longint):integer;
Function Malloc(Var Ptr; Size : Word) : Word;
Function Dalloc(Var Ptr) : Word;
Function DosMemAvail : LongInt;


IMPLEMENTATION

Function Malloc(Var Ptr; Size : Word) : Word;
Begin
   Inline(
     $8B/$46/<SIZE/         {            mov         ax,[bp+<Size]}
     $B9/$04/$00/           {            mov         cx,4}
     $D3/$E8/               {            shr         ax,cl}
     $40/                   {            inc         ax}
     $89/$C3/               {            mov         bx,ax}
     $B4/$48/               {            mov         ah,$48}
     $CD/$21/               {            int         $21             ;Allocate memory}
     $72/$07/               {            jc          AllocErr        ;If any errors ....}
     $C7/$46/$FE/$00/$00/   {NoErrors:   mov word    [bp-2],0        ;Return 0 for successful allocation}
     $EB/$05/               {            jmp short   Exit}
     $89/$46/$FE/           {AllocErr:   mov         [bp-2],ax       ;Return error code}
     $31/$C0/               {            xor         ax,ax           ;Store a NIL value into the ptr}
     $C4/$7E/<PTR/          {Exit:       les         di,[bp+<Ptr]    ;Address of pointer into es:di}
     $50/                   {            push        ax              ;Save the Segment part}
     $31/$C0/               {            xor         ax,ax           ;Offset is always 0}
     $FC/                   {            cld                         ;Make sure direction is upward}
     $AB/                   {            stosw                       ;Store offset of memory block}
     $58/                   {            pop         ax              ;Get back segment part}
     $AB);                  {            stosw                       ;Store segment of memory block}
   
End {Malloc};

{ --------------------------------------------------------------------------- }

Function Dalloc(Var Ptr) : Word;
Begin
   If Pointer(Ptr) <> NIL then begin
      Inline(
        $B4/$49/               {            mov         ah,$49}
        $C4/$7E/<PTR/          {            les         di,[bp+<Ptr]}
        $26/$C4/$3D/           {        es: les         di,[di]}
        $CD/$21/               {            int         $21}
        $72/$02/               {            jc          Exit}
        $31/$C0/               {NoError:    xor         ax,ax}
        $89/$46/$FE);          {Exit:       mov         [bp-2],ax}
      Pointer(Ptr) := NIL;
      Dalloc := 0 ;
   end {if}
   else
      Dalloc := 1;
End {Dealloc};

{ --------------------------------------------------------------------------- }
Function DosMemAvail : LongInt;
Begin
   Inline(
     $BB/$FF/$FF/           {         mov         bx,$FFFF}
     $B4/$48/               {         mov         ah,$48}
     $CD/$21/               {         int         $21}
     $89/$D8/               {         mov         ax,bx}
     $B9/$10/$00/           {         mov         cx,16}
     $F7/$E1/               {         mul         cx}
     $89/$46/$FC/           {         mov         [bp-4],ax}
     $89/$56/$FE);          {         mov         [bp-2],dx}
end {DosMemAvail};


procedure glinie(x1,x2,y:word;farbe:byte);assembler;
asm
 mov  ax,seite
 mov  es,ax
 mov  si,x1
 mov  dx,3c4h

 mov  ax,y
 mov  di,ax
 shl  ax,2
 add  di,ax
 shl  di,4
 mov  ax,si
 shr  ax,2
 add  di,ax  {offset von x1 nach di}

 mov  ax,si
 shr  ax,2        { x div 4}
 mov  bx,x2      {offsett von x2 berechnen }
 shr  bx,2
 sub  bx,ax      {x2-x1}
 jnz  @weiter    {wenn nicht null bei operation davor dann springe}

 mov  al,2
 mov  cx,si
 and  cl,3
 mov  ah,$e0
 rol  ah,cl
 mov  cx,x2
 and  cl,3
 inc  cx
 mov  bh,15
 shl  bh,cl
 or   ah,bh
 xor  ah,$0f
 out  dx,ax    {neu berechnete bitplane die von x1-x2 geht setzen}
 mov  al,farbe
 stosb
jmp @linieuntenende
@weiter:
 mov  cx,x1         {bitplane von x1 berechnen}
 and  cl,3
 mov  ah,15      {XXXX shr bitplane von x1}
 shl  ah,cl
 mov  al,2
 out  dx,ax   {bitplane setzen}
 mov  al,farbe
 stosb
{dword beginnt hier}
 mov  ax,0f02h
 out  dx,ax  {alle bitplanes ein}

 mov  ah,farbe
 mov  al,ah
 db 66h,0fh,0ach,0c0h,10h { shrd eax,eax,16}
 mov  ah,farbe
 mov  al,ah

 dec  bx
 shr  bx,1  {anzahl offsetts in bx}
 jnc  @2
 stosb
@2:
 shr  bx,1
 jnc @3
 stosw
@3:
 mov  cx,bx
 db 0f3h,66h,0abh     { rep stosd}
@wenigloop:
 mov  cx,x2
 and  cl,3
 mov  al,1
 shl  al,cl  {bitplane des endpunktes x2 berechnen}
 xor  ah,ah
 shl  ax,1  {bitplane von 0 bis letzter (x2 berechnen}
 dec  ax    {  2*(bitplane x2)-1}
 mov  ah,al
 mov  al,2
 out  dx,ax   {bitplane setzen}
 mov  al,farbe
 stosb
@linieuntenende:
end;

procedure videomodus;
begin
asm
 mov ax,0013h
 int 10h
 mov dx,3c4h
 mov al,4
 out dx,al
 inc dx
 in  al,dx
 and al,0f7h
 or  al,4h
 out dx,al
 dec dx
 mov ax,0f02h
 out dx,ax
 mov ax,0a000h
 mov seite,ax
 mov es,ax
 xor di,di
 xor ax,ax
 mov cx,8000h
 cld
 rep stosw
 mov dx,3d4h
 mov al,14h
 out dx,al
 inc dx
 in  al,dx
 and al,0bfh
 out dx,al
 dec dx
 mov al,17h
 out dx,al
 inc dx
 in  al,dx
 or  al,40h
 out dx,al
end;
 bildbreite(320);
end;

procedure enter400;assembler;
asm
mov  dx,3d4h
mov  al,9
out  dx,al
inc  dx
in   al,dx
and  al,01110000b
out  dx,al
end;

procedure enter200;assembler;
asm
mov  dx,3d4h
mov  al,9
out  dx,al
inc  dx
in   al,dx
or   al,10000000b
out  dx,al
end;

procedure textmodus;assembler;
asm
 mov ax,0003h
 Int 10h
end;

procedure altvideomodus;assembler;
asm
 mov ax,0013h
 int 10h
 mov seite,0a000h;
end;

procedure enable;assembler;
asm
 mov dx,3c4h
 mov ax,0f02h
 out dx,ax
 mov dx,3ceh
 mov ax,4105h
 out dx,ax
end;

procedure disable;assembler;
asm
 mov dx,3c4h
 mov ax,0f02h
 out dx,ax
 mov dx,3ceh
 mov ax,4005h
 out dx,ax
end;

procedure waitretrace;
begin
 repeat until (port[$3d4+6] and $08) = 0;
 repeat until (port[$3d4+6] and $08) > 0;
end;

procedure waitdisplay;
begin
 repeat until (port[$3d4+6] and $08) > 0;
 repeat until (port[$3d4+6] and $08) = 0;
end;

procedure verknuepfungsart(art:byte);ASSEMBLER;
asm
mov dx,3ceh
mov al,3h
mov ah,art
mov cl,3
shl ah,cl
out dx,ax
end;

procedure aktiveadresse(x,y:word);
begin
 seite:=$a000+(y*bbreite+x shr 2) shr 4;
end;

procedure startadresse(x,y:word);
begin
 port[$3d4]:=$0C;
 port[$3d5]:=hi(y*bbreite+x shr 2);
 port[$3d4]:=$0D;
 port[$3d5]:=lo(y*bbreite+x shr 2);
end;

procedure bildbreite(br:word);
begin
port[$3d4]:=$13;
port[$3d5]:=br shr 3;
bbreite:=br shr 2;
end;

procedure aktiveseite(seit:byte);
begin
 case seit of
  0 : aktiveadresse(0,0);
  1 : aktiveadresse(0,200);
  2 : aktiveadresse(0,400);
  3 : aktiveadresse(0,600);
 end;
end;

procedure seiteanzeigen(seit:byte);
begin
 case seit of
  0 : startadresse(0,0);
  1 : startadresse(0,200);
  2 : startadresse(0,400);
  3 : startadresse(0,600);
 end;
end;

procedure seitekopieren(qpage,zpage:word);assembler;
asm
 call enable
 push ds
 mov  bx,16000
 mov  ax,qpage
 mul  bx
 mov  si,ax
 mov  ax,zpage
 mul  bx
 mov  di,ax
 mov  ax,0a000h
 mov  es,ax
 mov  ds,ax
 mov  cx,16000
 rep  movsb
 pop  ds
end;

procedure cls(nr:word);assembler;
asm
 mov  dx,3c4h
 mov  al,2
 mov  ah,0fh
 out  dx,ax
 mov  ax,16000
 mul  nr
 mov  di,ax
 mov  ax,0a000h
 mov  es,ax
 cld
 db 66h,33h,0c0h
 mov  cx,4000
 db 0f3h,66h,0abh
end;


procedure altcls;assembler;
asm
 mov  al,2
 mov  dx,3c4h
 in   ax,dx
 mov  bx,ax
 mov  al,2
 mov  ah,00001111b
 out  dx,ax
 mov  ax,0a000h
 mov  es,ax
 mov  al,0
 mov  di,0
@looping:
 stosb
 cmp di,32000
 jl  @looping
 mov  ax,0a7d0h
 mov  es,ax
 mov  al,0
 mov  di,0
@looping1:
 stosb
 cmp di,32000
 jl  @looping1
 mov  ax,bx
 out  dx,ax
end;

procedure punkt(x,y:word;farbe:byte);assembler;
asm
 mov  ax,y
{ shl  ax,1
 mov  dx,ax
 shl  ax,1
 shl  ax,1
 add  ax,dx
 shl  ax,1
 shl  ax,1
 shl  ax,1}
 mul  bbreite
 mov  cx,x
 mov  bx,cx
 shr  bx,1
 shr  bx,1
 add  ax,bx
 mov  di,ax
 and  cl,3
 mov  ah,1
 shl  ah,cl
 mov  al,2
 mov  dx,3c4h
 out  dx,ax
 mov  ax,seite
 mov  es,ax
 mov  al,farbe
 stosb
end;

function punktfarbe(x,y:word):byte;
var
 test:byte;
begin
asm
 mov  ax,y
{ shl  ax,1
 mov  dx,ax
 shl  ax,1
 shl  ax,1
 add  ax,dx
 shl  ax,1
 shl  ax,1
 shl  ax,1}
 mul  bbreite
 mov  si,x
 mov  cx,si
 shr  si,1
 shr  si,1
 add  si,ax
 and  cl,3
 mov  ah,cl
 mov  al,4
 mov  dx,3ceh
 out  dx,ax
 mov  ax,seite
 mov  es,ax
 mov  al,es:[si]
 mov  test,al
end;
 punktfarbe:=test;
end;


procedure extrafarbe(farben,r,g,b:byte);assembler;
asm
 mov dx,$3c8
 mov al,farben
 out dx,al
 cli
 mov dx,$3c9
 mov al,r
 out dx,al
 mov al,g
 out dx,al
 mov al,b
 out dx,al
 sti
end;

procedure extrafarbelesen(farben:byte);assembler;
asm
 mov dx,$3c7
 mov al,farben
 out dx,al
 cli
 mov dx,$3c9
 in  al,dx
 mov rot,al
 in  al,dx
 mov gruen,al
 in  al,dx
 mov blau,al
 sti
end;

procedure paletteschreiben(var palette:palettenarray;farbenstart,farbenende:byte);
var
 zaehler : integer;
begin
 for zaehler:=farbenstart to farbenende do
 extrafarbe(zaehler,palette[zaehler,1],palette[zaehler,2],palette[zaehler,3]);
end;

procedure palettelesen(var palette:palettenarray;farbenstart,farbenende:byte);
var
 zaehler : integer;
begin
 for zaehler:=farbenstart to farbenende do begin
 extrafarbelesen(zaehler);
 palette[zaehler,1]:=rot;
 palette[zaehler,2]:=gruen;
 palette[zaehler,3]:=blau;
 end;
end;

procedure palettespeichern(var palette:palettenarray;dateiname:string);
var
 palettendatei : file of byte;
 zaehler       : integer;
begin
 assign(palettendatei,dateiname+'.pal');
 rewrite(palettendatei);
 for zaehler:=0 to 255 do
 write(palettendatei,palette[zaehler,1],palette[zaehler,2],palette[zaehler,3]);
 close(palettendatei);
end;

procedure paletteladen(var palette:palettenarray;dateiname:string;start:longint);
var
 palettendatei : file of byte;
 zaehler       : integer;
begin
 assign(palettendatei,dateiname);
 reset(palettendatei);
 seek(palettendatei,start);
 for zaehler:=0 to 255 do
 read(palettendatei,palette[zaehler,1],palette[zaehler,2],palette[zaehler,3]);
 close(palettendatei);
end;

procedure graustufen(farben,anzahlreg:word);assembler;
asm
 mov ah,10h
 mov al,1bh
 mov bx,farben
 mov cx,anzahlreg
 int 10h
end;

procedure setpal;assembler;
asm
 push ds
 pop  es
 mov  dx,offset palette
 mov  ax,1012h
 xor  bx,bx
 mov  cx,0100h
 int  10h
end;

procedure gifopen;assembler;
asm
 mov ax,03d00h
 lea dx,gifname + 1
 int 21h
 mov handle,ax
end;

procedure gifread(n:word);assembler;
asm
 mov ax,03f00h
 mov bx,handle
 mov cx,n
 lea dx,puf
 int 21h
end;

procedure gifseekdelta(delta:longint);assembler;
asm
 mov ax,04200h
 mov bx,handle
 mov cx,word ptr delta + 2
 mov dx,word ptr delta
 int 21h
end;

procedure gifclose;assembler;
asm
 mov ax,03e00h
 mov bx,handle
 int 21h
end;

procedure shiftpal;assembler;
asm
 push ds
 pop  es
 mov  si,offset Puf
 mov  di,offset Palette
 mov  cx,768
@l1:
 lodsb
 shr  al,2
 stosb
 loop @l1
end;

procedure fillpuf;
begin
 gifread(1);
 restbyte:=puf[0];
 gifread(restbyte);
end;

function getphysbyte:byte;assembler;
asm
 push bx
 cmp  restbyte,0
 ja   @restda
 pusha
 call fillpuf
 popa
 mov  pufind,0
@restda:
 mov  bx,PufInd
 mov  al,byte ptr puf[bx]
 inc  pufind
 pop  bx
end;

function getlogbyte:word;assembler;
asm
 push si
 mov  ax,breite
 mov  si,ax
 mov  dx,restbits
 mov  cx,8
 sub  cx,dx
 mov  ax,lbyte
 shr  ax,cl
 mov  code,ax
 sub  si,dx
@nextbyte:
 call getphysbyte
 xor  ah,ah
 mov  lbyte,ax
 dec  restbyte
 mov  bx,1
 mov  cx,si
 shl  bx,cl
 dec  bx
 and  ax,bx
 mov  cx,dx
 shl  ax,cl
 add  code,ax
 sbb  dx,breite
 add  dx,8
 jns  @positiv
 add  dx,8
@positiv:
 sub  si,8
 jle  @fertig
 add  dx,breite
 sub  dx,8
 jmp  @nextbyte
@fertig:
 mov  restbits,dx
 mov  ax,code
 pop  si
end;

procedure gifladen(dateiname:string);
var ziel,quelle,qseg,bpos,
    pic_size,pic_height,pic_width,
    x_count,plane_pos_i : word;
    plane_pos           : array[0..3] of pointer;
    plane               : byte;
begin
 case seite of
  $a000 : bpos:=0;
  $a3e8 : bpos:=16000;
  $a7d0 : bpos:=32000;
  $abb8 : bpos:=48000;
 end;
 gifname:=dateiname+'.gif'+#0;
 getmem(temppic,64000);
 gifopen;
 gifseekdelta(13);
 gifread(768);
 shiftpal;
 setpal;
 gifread(1);
 while puf[0] = $21 do begin
 gifread(2);
 gifread(puf[1]+1);
 end;
 gifread(10);
 pic_width:=puf[4]+puf[5]*256;
 pic_height:=puf[6]+puf[7]*256;
 pic_size:=pic_width div 4 * pic_height;
 If puf[8] and 128 = 128 then begin
 gifread(768);
 shiftpal;
 SetPal;
 end;
 plane_pos[0]:=temppic;
 plane_pos[1]:=ptr(seg(temppic^)+pic_size div 16,  0);
 plane_pos[2]:=ptr(seg(temppic^)+pic_size div  8,  0);
 plane_pos[3]:=ptr(seg(temppic^)+(pic_size div 16)*3, 0);
 plane_pos_i:=6;
 plane:=1;
 lbyte:=0;
asm
 les  di,temppic
 mov  free,258   {1. freie Posit in Alphabet}
 mov  breite,9   {Zeichenbreite in bit}
 mov  max,511    {maximaler darstellbarer Wert bei akt breite}
 mov  stackp,0
 mov  restbits,0
 mov  restbyte,0
 xor  si,si      {aktuelle Plane (fr Zieladdressierung)}
@mainloop:
 call getlogByte
 cmp  ax,257
 je   @abbruch
 cmp  ax,256
 je   @clear
 mov  readbyt,ax
 cmp  ax,free
 jb   @code_in_ab
 mov  ax,old_code
 mov  code,ax
 mov  bx,stackp
 mov  cx,sonderfall
 mov  word ptr stack[bx],cx
 inc  stackp
@code_in_ab:
 cmp  ax,256
 jb   @konkret
 @fillstack_loop:
 mov  bx,code
 shl  bx,1
 push bx
 mov  ax,word ptr ab_tail[bx]
 mov  bx,stackp
 shl  bx,1
 mov  word ptr stack[bx],ax
 inc  stackp
 pop  bx
 mov  ax,word ptr ab_prfx[bx]
 mov  code,ax
 cmp  ax,256
 ja   @fillstack_loop
@konkret:
 mov  bx,stackp
 shl  bx,1
 mov  word ptr stack[bx],ax
 mov  sonderfall,ax
 inc  stackp
 mov  bx,stackp
 dec  bx
 shl  bx,1
@readstack_loop:
 mov  ax,word ptr stack[bx]
 mov  di,word ptr plane_pos[si] + 2
 mov  es,di
 mov  di,word ptr plane_pos[si]
 stosb
 inc  word ptr plane_pos[si]
 add  si,4
 and  si,12
 or   di,di
 jne  @rsnc
 mov  ax,es
 add  ax,1000h
 mov  es,ax
@rsnc:
 dec  bx
 dec  bx
 jns  @readstack_loop
 mov  stackp,0
 mov  bx,free
 shl  bx,1
 mov  ax,old_code
 mov  word ptr ab_prfx[bx],ax
 mov  ax,code
 mov  word ptr ab_tail[bx],ax
 mov  ax,readbyt
 mov  old_code,ax
 inc  free
 mov  ax,free
 cmp  ax,max
 jbe  @mainloop
 cmp  byte ptr breite,12
 jae  @mainloop
 inc  breite
 mov  cl,byte ptr breite
 mov  ax,1
 shl  ax,cl
 dec  ax
 mov  max,ax
 jmp  @mainloop
@clear:
 mov  breite,9
 mov  max,511
 mov  free,258
 call getlogbyte
 mov  sonderfall,ax
 mov  old_code,ax
 mov  di,word ptr plane_pos[si] + 2
 mov  es,di
 mov  di,word ptr plane_pos[si]
 stosb
 inc  word ptr plane_pos[si]
 add  si,4
 and  si,12
 or   di,di
 jne  @mainloop
 mov  ax,es
 add  ax,1000h
 mov  es,ax
 jmp  @mainloop
@abbruch:
 end;
 gifclose;
asm
 push ds
 lds  si,temppic
 mov  ax,0a000h
 mov  es,ax
 mov  di,bpos
 mov  ziel,di
 mov  cx,pic_size
@lpplane:
 mov  al,02h
 mov  ah,plane
 mov  dx,3c4h
 out  dx,ax
@lp1:
 rep  movsb
 mov  di,ziel
 mov  si,plane_pos_i
 mov  si,word ptr plane_pos[si]
 add  plane_pos_i,4
 mov  ds,si
 xor  si,si
 mov  cx,pic_size
 shl  plane,1
 cmp  plane,10h
 jne  @lpplane
 pop  ds
 end;
 freemem(temppic,64000);
end;

procedure bildladen(dateiname:string;altneu:boolean;start,ende:longint);
const
 dateiposition : longint = 0;
 puffermax     : word    = 4000;
var
 pcxheader        : pcxheadertyp;
 pcxdatei         : file;
 puffer           : array[1..4000] of byte;
 dateigroesse     : longInt;
 lesemenge        : word;
 zaehler,zaehler1 : integer;
procedure bildinit;
var
 zaehler1 : integer;
begin
 if fc=0 then begin
 seek(pcxdatei,dateigroesse-769);
 blockread(pcxdatei,puffer,769);
 if ioresult <> 0 then fc:=3 else
 if puffer[1]=12 then begin zaehler:=2;
 for zaehler1:=0 to 255 do begin
 pufferpalette[zaehler1,1]:=puffer[zaehler] shr 2;
 pufferpalette[zaehler1,2]:=puffer[zaehler+1] shr 2;
 pufferpalette[zaehler1,3]:=puffer[zaehler+2] shr 2;
 inc(zaehler,3);end;
 paletteschreiben(pufferpalette,0,255);
 seek(pcxdatei,start+128);
 end
 else fc:=7;end;
end;
procedure pufferlesen;
begin
 if dateiposition <= dateigroesse-puffermax-769 then lesemenge:=puffermax
 else lesemenge:=dateigroesse-dateiposition-769;
 if lesemenge <> 0 then begin
 blockread(pcxdatei,puffer,lesemenge);
 if ioresult <> 0 then fc:=3
 else inc(dateiposition,lesemenge);
 end;
end;
procedure bildanzeigen;
var
         x,y           : word;
         faktor,farbe  : byte;
 hilf,zaehler,zaehler1 : integer;
begin
 x:=0;y:=0;
 with pcxheader do begin
 repeat
 pufferlesen;
 if (fc=0) and (lesemenge<>0) then begin zaehler:=1;
 repeat
 if puffer[zaehler] >= 193 then
 if zaehler <= lesemenge-1 then begin
 faktor:=puffer[zaehler]-192;
 farbe:=puffer[zaehler+1];
 inc(zaehler,2);
 end
 else begin
 faktor:=puffer[zaehler]-192;
 pufferlesen;
 if (fc=0) and (lesemenge<>0) then begin
 farbe:=puffer[1];
 zaehler:=2;
 end;
 end
 else begin faktor:=1;farbe:=puffer[zaehler];inc(zaehler);end;
 if (fc=0) and (lesemenge <> 0) then
 for zaehler1:=1 to faktor do begin
 if altneu then punkt(x,y,farbe) else mem[$a000:y*320+x]:=farbe;
 if x=pcxheader.xende then begin
 x:=0;
 inc(y);
 end else inc(x);
 end
 until(zaehler > lesemenge) or (fc <> 0);
 end
 until(dateiposition>=dateigroesse-769) or (fc <> 0);
 end;
end;
begin
 fc:=0;
 assign(pcxdatei,dateiname);
 reset(pcxdatei,1);
 if ioresult <> 0 then fc:=1
 else begin
 dateigroesse:=ende;
 seek(pcxdatei,start);
 blockread(pcxdatei,pcxheader,sizeof(pcxheader));
 if ioresult <> 0 then fc:=3
 else with pcxheader do
 if (kennung <> 10)
 or (version <> 5)
 or (kodierung <> 1)
 or (bitspixel <> 8)
 or (anzebenen <> 1) then fc:=5
 else begin
 bildinit;
 if fc=0 then begin
 dateiposition:=start+128;
 bildanzeigen;
 end;
 end;
 close(pcxdatei);
 end;
end;

procedure standardzeichensatzladen;
begin
 move(ptr($ffa6,$e)^,zeichensatz,128*8);
 move(ptr(mem[$0:$7e],mem[$0:$7c])^,ptr(seg(zeichensatz),
 ofs(zeichensatz)+128*8)^,128*8);
end;

procedure readkey;assembler;
asm
 xor ax,ax
 int 16h
 mov ze,al
 cmp al,0
 jne @s
 mov ze,ah
@s:
end;

function keypressed:boolean;
var
 test:byte;
begin
asm
 mov ah,0bh
 int 21h
 mov test,al
end;
 if test>0 then keypressed:=true else keypressed:=false;
end;

procedure switchoff;assembler;
asm
 mov dx,$3c4
 mov al,1
 out dx,al
 inc dx
 in al,dx
 or al,$20
 out dx,al
end;

procedure switchon;assembler;
asm
 call waitretrace
 mov dx,$3c4
 mov al,1
 out dx,al
 inc dx
 in al,dx
 and al,$df
 out dx,al
end;

procedure warte(i:word);
var k:integer;
begin
 for k:=1 to i do waitretrace;
end;

procedure paletteaus(wielange:byte);
var i,j:integer;
begin
 palettelesen(blendepal,0,255);
 for j:=0 to 64 do
 begin
  warte(wielange);
  for i:=0 to 255 do
  begin
   extrafarbelesen(i);
   if rot>0 then dec(rot);
   if gruen>0 then dec(gruen);
   if blau>0 then dec(blau);
   extrafarbe(i,rot,gruen,blau);
  end;
 end;
end;

procedure paletteein(wielange:byte);
var i,j:integer;
begin
 for j:=0 to 64 do
 begin
  warte(wielange);
  for i:=0 to 255 do
  begin
   extrafarbelesen(i);
   if rot<blendepal[i,1] then inc(rot);
   if rot>blendepal[i,1] then dec(rot);
   if gruen<blendepal[i,2] then inc(gruen);
   if gruen>blendepal[i,2] then dec(gruen);
   if blau<blendepal[i,3] then inc(blau);
   if blau>blendepal[i,3] then dec(blau);
   extrafarbe(i,rot,gruen,blau);
  end;
 end;
end;

procedure blitzeinall;
var i:integer;
begin
 palettelesen(blendepal,0,255);
 waitretrace;
 for i:=0 to 255 do extrafarbe(i,63,63,63);
end;

procedure blitzausall;
var i:integer;
begin
 waitretrace;
 paletteschreiben(blendepal,0,255);
end;

procedure blitzein;
var i:integer;
begin
 i:=0;
 repeat
  waitretrace;
  extrafarbe(0,i,i,i);
  inc(i,4);
 until i=60;
end;

procedure blitzaus;
var i:integer;
begin
 i:=56;
 repeat
  waitretrace;
  extrafarbe(0,i,i,i);
  dec(i);
 until i=0;
end;

function wurzel(zahl:longint):integer;
var t:integer;
begin
asm
mov ax,word ptr zahl
mov dx,word ptr zahl+2
db 66h
xor si,si
db 66h,0fh,0ach,0d3h,10h
mov bx,ax
db 66h
xor dx,dx
db 66h
mov cx,bx
db 66h
mov ax,bx
@iterat:
db 66h
idiv bx
db 66h
xor dx,dx
db 66h
add ax,bx
db 66h
shr ax,1
db 66h
sub si,ax
db 66h
cmp si,1
jbe @fertig
db 66h
mov si,ax
db 66h
mov bx,ax
db 66h
mov ax,cx
jmp @iterat
@fertig:
mov t,ax
end;
wurzel:=t;
end;

end.